<template>
  <div class="the-table">
    <section class="section">
      <b-table
        :loading="isLoading"
        :narrowed="isNarrowed"
        :striped="isStriped"
        :paginated="isPaginated"
        :per-page="perPage"
        :data="content">

        <template slot-scope="props">

          <b-table-column
            v-for="(column, index) in columns"
            :key="index"
            :field="column.field"
            :label="column.label">
            <span v-if="column.field === 'created_at' || column.field === 'updated_at'">
              {{ new Date(props.row[column.field]).toLocaleString('pt-BR') }}
            </span>
            <span v-else-if="column.field === 'published_at'">
              {{ new Date(props.row[column.field]).toLocaleDateString('pt-BR') }}
            </span>
            <span v-else-if="column.field === 'price'">
              {{ toBRLCurrency(props.row[column.field]) }}
            </span>
            <span v-else>{{ props.row[column.field] }}</span>
          </b-table-column>

          <b-table-column
            field="actions"
            label="Ações"
            :centered=true>

              <div class="columns is-hidden-mobile">
                <!--
                <div class="column">
                  <a href=""  @click.prevent="readItem(props.row)">Visualizar</a>
                </div>
                -->
                <div class="column">
                  <a href="#"  @click.prevent="updateItem(props.row)">Editar</a>
                </div> <!-- column -->
                <div class="column">
                  <a href="#" @click.prevent="deleteItem(props.row)">Remover</a>
                </div> <!-- column -->
              </div> <!-- columns -->

              <div class="wrapper is-hidden-desktop">
                <!--
                <a href="#" @click.prevent="readItem(props.row)">
                  <b-icon icon="eye"></b-icon>
                </a>
                -->
                <a href="#" @click.prevent="updateItem(props.row)">
                  <b-icon icon="pencil"></b-icon>
                </a>
                <a href="#" @click.prevent="deleteItem(props.row)">
                  <b-icon icon="delete"></b-icon>
                </a>
              </div> <!-- wrapper -->

          </b-table-column>
        </template>

				<template slot="empty">
					<section class="section">
						<div class="content has-text-grey has-text-centered">
							<p>
								<b-icon
									icon="emoticon-sad"
									size="is-large">
								</b-icon>
							</p>
							<p>Nenhum dado a ser apresentado.</p>
						</div>
					</section>
				</template>


      </b-table>
    </section>
    <b-modal :active.sync="isModalActive" has-modal-card>
      <the-delete-modal
        :obj="obj"
        v-on:confirmDelete="confirmDelete"
        v-on:cancelDelete="cancelDelete"
        />
    </b-modal>
  </div>
</template>

<script>
import TheDeleteModal from '@/components/TheDeleteModal'

const formatter = new Intl.NumberFormat('pt-BR', {
  style: 'currency',
  currency: 'BRL',
  minimumFractionDigits: 2
})

export default {
  name: 'TheTable',
  directives: { formatter },
  props: {
    title: String,
    content: Array,
    columns: Array,
    isLoading: Boolean,
    perPage: String
  },
  components: {
    'the-delete-modal': TheDeleteModal
  },
  data ()  {
    return {
      isPaginated: true,
      isNarrowed: true,
      isStriped: true,
      isModalActive: false,
      obj: Object
    }
  },
  created () {},
  methods: {
    createItem: function () {
      console.log('createItem')
    },
    readItem: function (obj) {
      this.$emit('readItem', obj)
    },
    updateItem: function (obj) {
      this.$emit('updateItem', obj)
    },
    deleteItem: function (obj) {
      this.isModalActive = true
      this.obj = obj
    },
    confirmDelete: function (obj) {
      this.isModalActive = false
      this.$emit('deleteItem', obj)
    },
    cancelDelete: function () {
      this.isModalActive = false
    },
    toBRLCurrency: function (obj) {
      return formatter.format(obj)
    }
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
</style>
